
package gestoreChiavi;
import java.io.*;
import java.security.*;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.KeyStore;
/**
 * Title: Chiave Privata 
 * Description:  seleziona ed estratai la chiave privata dal keystore
 * Company: 
 * @author  Salvatore Marano
 * @version 1.0
 */

public class ChiavePrivata {

 public ChiavePrivata(){}     //costruttore


 public void go(String aliasCertificato,
                String keystorePassword,
                String privateKeyPassword ) {

    try{
         // costruzione del percorso del KeyStore che si trova
         String userHome=System.getProperty("user.home");
         String keystoreFilename=userHome + File.separator + ".keystore";

         // gestione della password e alias certificato
         String alias=aliasCertificato;
         char[] password=keystorePassword.toCharArray();
         char[] KeyPassword=privateKeyPassword.toCharArray();

         String nomeDellaChiave= aliasCertificato+".pk";

         // apertura del file keystore

         FileInputStream fIn= new FileInputStream(keystoreFilename);
         KeyStore keystore=KeyStore.getInstance("JKS");
         BufferedInputStream ksbufin= new  BufferedInputStream(fIn);
         // password e alias li passiamo al keystore
         keystore.load(ksbufin,password);


       //estrazione della chiave privata

        PrivateKey priv=(PrivateKey) keystore.getKey(alias ,KeyPassword);


       // salviamo la chiave estratta in un file codificato
       byte[] KeyPriv = priv.getEncoded();
       FileOutputStream keyPrivatefos = new FileOutputStream(nomeDellaChiave);
       keyPrivatefos.write( KeyPriv);
       keyPrivatefos.close();

      } catch (Exception e) {
            System.err.println("Caught exception " + e.toString());
        }

  }//go

}//chiavePrivata
