//******************************************************************//
//                                                                  //                                                                  //
//       TSpuntoLed Delphi 6 Visual Component                       //
//       Copyright 2002 Luca Spuntoni                               //
//       spuntosoft@tiscalinet.it                                   //
//                                                                  //                                                                  //
//******************************************************************//

unit SpuntoLedComponent;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls, Graphics;

type
  TSpuntoLed = class(TShape)
  private
    { Private declarations }
    SpuntoONColor : TColor;
    SpuntoOFFColor : TColor;
    SpuntoLedOn : Boolean;
    procedure SetLedParameters;
  protected
    { Protected declarations }
  public
    { Public declarations }
        constructor Create( AOwner : TComponent ); override;
        procedure LedOn;
        procedure LedOff;
  published
    { Published declarations }
    property SpuntoLedOnColor : TColor read SpuntoOnColor write SpuntoOnColor
                                       default clRed;
    property SpuntoLedOffColor : TColor read SpuntoOffColor write SpuntoOffColor
                                       default clMaroon;
    property SpuntoLedIsON: Boolean Read SpuntoLedOn;
  end;

procedure Register;

implementation

constructor TSpuntoLed.Create( AOwner : TComponent );
begin
  inherited Create( AOwner );
  SpuntoONColor :=clRed;
  SpuntoOFFColor:=clMaroon;
  SpuntoLedOn   :=False;
  Shape         :=stcircle;
  Width         := 15;
  Height        := 15;
  SetLedParameters;
end;

procedure TSpuntoLed.SetLedParameters;
Begin
 If SpuntoLedOn then Brush.Color:=SpuntoOnColor else Brush.Color:=SpuntoOffColor;
End;

procedure TSpuntoLed.LedOn;
Begin
 SpuntoLedOn:=True;
 SetLedParameters;
End;

procedure TSpuntoLed.LedOff;
Begin
 SpuntoLedOn:=False;
 SetLedParameters;
End;

procedure Register;
begin
  RegisterComponents('Spunto', [TSpuntoLed]);
end;

end.
