package serie_junit;
import junit.framework.*;

/**
 *  Test case per la classe Importo.
 */
public class TestImporto extends TestCase {

    public static void main(String[] args) {
        // versione testuale:
        //junit.textui.TestRunner.run(TestImporto.class);

        // versione grafica:
        junit.swingui.TestRunner.run(TestImporto.class);
    }

    /**
     *  Test per il metodo getValore().
     */
    public void testGetValore() {
        Importo i1 = new Importo(true, 12, 06);
        assertEquals(i1.getValore(), "12.06");
        Importo i2 = new Importo(false, 0, 99);
        assertEquals(i2.getValore(), "-0.99");
        Importo i3 = new Importo(true, 12, 100);
        assertEquals(i3.getValore(), "13.00");
        Importo i4 = new Importo(false, 12, 375);
        assertEquals(i4.getValore(), "-15.75");
    }

    /**
     *  Test per i valori negativi nel costruttore.
     */
    public void testCostruzioneSbagliata() {
      try {
        new Importo(true, -1, 0);
        fail("Mi aspettavo un'eccezione");
      } catch (NumberFormatException e) {}

      try {
        new Importo(true, 0, -1);
        fail("Mi aspettavo un'eccezione");
      } catch (NumberFormatException e) {}
    }

    /**
     *  Test per il costruttore a un solo parametro.
     */
    public void testCostruttoreAUnParametro() {
        Importo i1 = new Importo(1206);
        assertEquals(i1.getValore(), "12.06");
        Importo i2 = new Importo(-99);
        assertEquals(i2.getValore(), "-0.99");
        Importo i3 = new Importo(0);
        assertEquals(i3.getValore(), "0.00");
    }

    /**
     *  Test per i valori negativi nel costruttore.
     */
    public void testSomma() {
        Importo i0 = new Importo(true, 0, 0);
        Importo i1 = new Importo(true, 10, 10);
        Importo i2 = new Importo(true, 12, 1);
        Importo i3 = new Importo(false, 2, 13);

        Importo somma1e2 = i1.somma(i2);
        Importo somma1e3 = i1.somma(i3);
        Importo somma2e1 = i2.somma(i1);
        Importo somma2e3 = i2.somma(i3);
        Importo somma0e3 = i0.somma(i3);

        assertEquals(somma1e2.getValore(), "22.11");
        assertEquals(somma1e3.getValore(), "7.97");
        assertEquals(somma2e1.getValore(), somma1e2.getValore());
        assertEquals(somma2e3.getValore(), "9.88");
        assertEquals(somma0e3.getValore(), "-2.13");
    }

}
