// File: MySnakeGameCanvas.java

/* Codice di progetto per la classe. Questa versione di MySnakeGameCanvas
 * non implementa effettivamente il gioco, ma fornisce uno scheletro per
 * il test delle altre due classi appartenenti al progetto. Inoltre, mette
 * in evidenza l'interfaccia pubblica richiesta dalla versione finale della
 * classe.
 */ 

// Pacchetti utili alla classe.
import javax.microedition.lcdui.*;

// MySnakeGameCanvas estende la classe Canvas.
public class MySnakeGameCanvas extends Canvas {
	
	// Buffer grafico ad uso interno.
	private Image buffer;
	private Graphics b;
	
	// Per memorizzare il tipo di dispositivo.
	private int deviceType;
	
	// Costruttore.
	public MySnakeGameCanvas(int dt) {
		// Salva la tipologia del dispositivo comunicata dalla MIDlet.
		deviceType = dt;
		// Prepara il buffer ed il relativo contesto grafico.
		buffer = Image.createImage(getWidth(), getHeight());
		b = buffer.getGraphics();
		// Riempie il buffer di bianco.
		b.setGrayScale(255);
		b.fillRect(0, 0, getWidth(), getHeight());
	}
	
	// Questo metodo, richiesto da Canvas, stampa il buffer sul video.
	public void paint(Graphics g) {
		g.drawImage(buffer, 0, 0, Graphics.LEFT | Graphics.TOP);
	}
	
	// Per avviare una nuova partita.
	public void startGame() {
	}
	
	// Per interrompere la partita corrente.
	// Deve restituire true se  possibile interrompere, false altrimenti.
	public boolean stopGame() {
		return true;
	}
	
}