// File: MySnakeTitleCanvas.java

// Pacchetti utili alla classe.
import javax.microedition.lcdui.*;
import java.io.*;

// MySnakeTitleCanvas estende la classe Canvas.
public class MySnakeTitleCanvas extends Canvas {
	
	// Buffer grafico ad uso interno.
	private Image buffer;
	private Graphics b;
	
	// Costruttore.
	public MySnakeTitleCanvas(int deviceType) {
		// Creazione del buffer e del relativo contesto grafico.
		buffer = Image.createImage(getWidth(), getHeight());
		b = buffer.getGraphics();
		// L'immagine buffer viene riempita di bianco.
		b.setGrayScale(255);
		b.fillRect(0, 0, getWidth(), getHeight());
		// Sceglie il logo in base al dispositivo.
		String imgPath = null;
		switch (deviceType) {
		case MySnakeMIDlet.COLORS_DEVICE:
			imgPath = "/images/mysnake_colors.png";
			break;
		case MySnakeMIDlet.GRAYTONES_DEVICE:
			imgPath = "/images/mysnake_graytones.png";
			break;
		case MySnakeMIDlet.BW_DEVICE:
			imgPath = "/images/mysnake_bw.png";
			break;
		}
		// Carica l'immagine.
		try {
			Image img = Image.createImage(imgPath);
			// Se l'immagine  troppo ampia per lo schermo in uso si lancia
			// un'eccezione.
			if (getWidth() < img.getWidth() || getHeight() < img.getHeight()) {
				throw new Exception();
			}
			// Inserisce l'immagine al centro del buffer.
			b.drawImage(
				img,
				getWidth() / 2,
				getHeight() / 2,
				Graphics.HCENTER | Graphics.VCENTER
			);
		} catch (Exception e) {
			// In caso di eccezione (impossibile caricare l'immagine o schermo
			// troppo piccolo) il logo viene sostituito da una semplice scritta.
			b.setGrayScale(0);
			b.drawString(
				"MySNAKE",
				getWidth() / 2,
				getHeight() / 2,
				Graphics.BASELINE | Graphics.HCENTER
			);
		}
	}
	
	// Questo metodo, richiesto da Canvas, stampa il buffer sul video.
	public void paint(Graphics g) {
		g.drawImage(buffer, 0, 0, Graphics.LEFT | Graphics.TOP);
	}
	
}