#include <iostream.h>

/*  TIPO DEFINITO MEDIANTE TEMPLATE  */
template<class T>
struct Elemento
{
  T info;
  Elemento* next;
};

/*  CLASSE DEFINITA MEDIANTE TEMPLATE  */

// Si noti che si fa uso del tipo
// appena definito (poco sopra), e
// si ottiene una struttura molto
// versatile e potente (oltre che
// utile in pratica)

template<class E>
class Insieme
{
  public:
    //campi pubblici, ad esempio
    Insieme();
    void Aggiungi(E);
      //sarebbero utili:
      //void Elimina(E);
      //bool Contiene(E);
      //bool isVuoto();
      //bool operator==(const Insieme&);

  private:
    //campi privati, ad esempio
    Elemento<E>* primo;
};

template<class E>
Insieme<E>::Insieme()
{
  primo = NULL;
}

template<class E>
void Insieme<E>::Aggiungi(E elem)
{
  //si potrebbero implementare controlli
  //per evitare duplicazioni di elementi
  Elemento<E>* temp = new Elemento<E>;
  temp->info = elem;
  temp->next = primo;
  primo = temp;
}

/*  FUNZIONE DEFINITA MEDIANTE TEMPLATE  */
template<class T>
bool SonoUguali(T elem1,T elem2)
{
  return elem1==elem2;
}

/*  FUNZIONE MAIN  */
int main()
{
  //esempio della funzione definita mediante template
  int n1 = 10;
  int n2 = 20;
  if(SonoUguali(n1,n2))
    cout << "Gli elementi sono uguali!\n";
  else
    cout << "Gli elementi sono diversi!\n";
  int n3 = 20;
  if(SonoUguali(n3,n2))
    cout << "Gli elementi sono uguali!\n";
  else
    cout << "Gli elementi sono diversi!\n";

  //esempio di uso della classe definita mediante template
  Insieme<int> insInteri;
  insInteri.Aggiungi(n1);
  insInteri.Aggiungi(n2);
  insInteri.Aggiungi(n3);

  return 0;
}

